
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class FinishesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const finishes = await db.finishes.create(
            {
                id: data.id || undefined,
        
        name_ar: data.name_ar
        ||
        null
            ,
            
        description_ar: data.description_ar
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.finishes.getTableName(),
                belongsToColumn: 'example_images',
                belongsToId: finishes.id,
            },
            data.example_images,
            options,
        );
        

        return finishes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const finishesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name_ar: item.name_ar
            ||
            null
            ,
            
                description_ar: item.description_ar
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const finishes = await db.finishes.bulkCreate(finishesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < finishes.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.finishes.getTableName(),
                    belongsToColumn: 'example_images',
                    belongsToId: finishes[i].id,
                },
                data[i].example_images,
                options,
            );
        }
        

        return finishes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const finishes = await db.finishes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name_ar !== undefined) updatePayload.name_ar = data.name_ar;
        
        
        if (data.description_ar !== undefined) updatePayload.description_ar = data.description_ar;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await finishes.update(updatePayload, {transaction});

        
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.finishes.getTableName(),
                belongsToColumn: 'example_images',
                belongsToId: finishes.id,
            },
            data.example_images,
            options,
        );
        

        return finishes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const finishes = await db.finishes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of finishes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of finishes) {
                await record.destroy({transaction});
            }
        });


        return finishes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const finishes = await db.finishes.findByPk(id, options);

        await finishes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await finishes.destroy({
            transaction
        });

        return finishes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const finishes = await db.finishes.findOne(
            { where },
            { transaction },
        );

        if (!finishes) {
            return finishes;
        }

        const output = finishes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.example_images = await finishes.getExample_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



      {
        model: db.file,
        as: 'example_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'finishes',
                        'name_ar',
                        filter.name_ar,
                    ),
                };
            }
            
            if (filter.description_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'finishes',
                        'description_ar',
                        filter.description_ar,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.finishes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'finishes',
                        'name_ar',
                        query,
                    ),
                ],
            };
        }

        const records = await db.finishes.findAll({
            attributes: [ 'id', 'name_ar' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name_ar', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name_ar,
        }));
    }

    
};

